<?php

namespace Faker\Estonia;

use Faker\Extension\Extension;

class PhoneNumber extends \Faker\Provider\PhoneNumber implements Extension
{
    protected static $formats = [
        '{{landlinePhoneNumber}}',
        '{{mobilePhoneNumber}}',
    ];

    /**
     * {@link} https://en.wikipedia.org/wiki/Telephone_numbers_in_Estonia
     */
    protected static $landlineFormats = [
        '32# ####',
        '33# ####',
        '35# ####',
        '38# ####',
        '39# ####',
        '43# ####',
        '44# ####',
        '45# ####',
        '46# ####',
        '47# ####',
        '48# ####',
        '60# ####',
        '61# ####',
        '62# ####',
        '63# ####',
        '64# ####',
        '65# ####',
        '66# ####',
        '67# ####',
        '68# ####',
        '71# ####',
        '72# ####',
        '73# ####',
        '74# ####',
        '75# ####',
        '76# ####',
        '77# ####',
        '78# ####',
        '79# ####',
        '88# ####',
        '+372 32# ####',
        '+372 33# ####',
        '+372 35# ####',
        '+372 38# ####',
        '+372 39# ####',
        '+372 43# ####',
        '+372 44# ####',
        '+372 45# ####',
        '+372 46# ####',
        '+372 47# ####',
        '+372 48# ####',
        '+372 60# ####',
        '+372 61# ####',
        '+372 62# ####',
        '+372 63# ####',
        '+372 64# ####',
        '+372 65# ####',
        '+372 66# ####',
        '+372 67# ####',
        '+372 68# ####',
        '+372 71# ####',
        '+372 72# ####',
        '+372 73# ####',
        '+372 74# ####',
        '+372 75# ####',
        '+372 76# ####',
        '+372 77# ####',
        '+372 78# ####',
        '+372 79# ####',
        '+372 88# ####',
    ];

    protected static $mobileFormats = [
        '50# ####',
        '510 ####',
        '511 ####',
        '512 ####',
        '513 ####',
        '514 ####',
        '515 ####',
        '516 ####',
        '517 ####',
        '518 ####',
        '5195 ###',
        '52# ####',
        '550 ####',
        '551 ####',
        '552 ####',
        '553 ####',
        '554 ####',
        '557 ####',
        '558 ####',
        '5640 ###',
        '5641 ###',
        '5642 ###',
        '5643 ###',
        '5644 ###',
        '5651 ###',
        '5652 ###',
        '5653 ###',
        '5654 ###',
        '5655 ###',
        '5658 ###',
        '5659 ###',
        '5### ####',
        '83## ####',
        '84## ####',
        '+372 5### ####',
        '+372 83## ####',
        '+372 84## ####',
        '+372 50# ####',
        '+372 510 ####',
        '+372 511 ####',
        '+372 512 ####',
        '+372 513 ####',
        '+372 514 ####',
        '+372 515 ####',
        '+372 516 ####',
        '+372 517 ####',
        '+372 518 ####',
        '+372 5195 ###',
        '+372 52# ####',
        '+372 550 ####',
        '+372 551 ####',
        '+372 552 ####',
        '+372 553 ####',
        '+372 554 ####',
        '+372 557 ####',
        '+372 558 ####',
        '+372 5640 ###',
        '+372 5641 ###',
        '+372 5642 ###',
        '+372 5643 ###',
        '+372 5644 ###',
        '+372 5651 ###',
        '+372 5652 ###',
        '+372 5653 ###',
        '+372 5654 ###',
        '+372 5655 ###',
        '+372 5658 ###',
        '+372 5659 ###',
    ];

    protected static $freeserviceFormats = [
        '+372 8000 ####',
        '+372 8001 ####',
        '+372 8002 ###',
        '+372 8003 ###',
        '+372 8004 ###',
        '+372 8005 ###',
        '+372 8006 ###',
        '+372 8007 ###',
        '+372 8008 ###',
        '+372 8009 ###',
        '8000 ####',
        '8001 ####',
        '8002 ###',
        '8003 ###',
        '8004 ###',
        '8005 ###',
        '8006 ###',
        '8007 ###',
        '8008 ###',
        '8009 ###',
    ];

    /**
     * @example '573 2462'
     *
     * @return string
     */
    public function landlinePhoneNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$landlineFormats)));
    }

    /**
     * @example '573 2462'
     *
     * @return string
     */
    public function mobilePhoneNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$mobileFormats)));
    }

    /**
     * @example '8000 5183'
     *
     * @return string
     */
    public function freeserviceNumber()
    {
        return static::numerify($this->generator->parse(static::randomElement(static::$freeserviceFormats)));
    }
}
